summaryrefslogtreecommitdiff
path: root/tests/lib
diff options
context:
space:
mode:
Diffstat (limited to 'tests/lib')
-rw-r--r--tests/lib55
1 files changed, 42 insertions, 13 deletions
diff --git a/tests/lib b/tests/lib
index b6bf810..1373020 100644
--- a/tests/lib
+++ b/tests/lib
@@ -32,6 +32,11 @@ incoming = $tmp/incoming
run_dinstall = 0
END
+fail () {
+ echo >&2 "failed: $*"
+ exit 1
+}
+
t-worktree () {
rm -rf $p
tar xf $troot/worktrees/${p}_$1.tar
@@ -54,8 +59,7 @@ t-has-ancestor () {
local ancestor=`git rev-parse $1^{}`
local mbase=`git merge-base $ancestor $now`
if [ x$mbase != x$ancestor ]; then
- echo "not ff $ancestor..$now, $mbase != $ancestor"
- exit 1
+ fail "not ff $ancestor..$now, $mbase != $ancestor"
fi
}
@@ -91,7 +95,8 @@ t-diff-nogit () {
t-cloned-fetched-good () {
t-diff-nogit ../extract/$p-${v%-*} .
t-clean-on-branch dgit/sid
- t-refs-same \
+ t-refs-same-start
+ t-refs-same-more \
refs/heads/dgit/sid \
refs/remotes/dgit/dgit/sid
t-refs-notexist dgit/unstable remotes/dgit/dgit/unstable
@@ -116,24 +121,46 @@ t-git-get-ref () {
'
}
-t-refs-same () {
- local f=$1
- t-git-get-ref $f >$tmp/t.ref1
- t-refs-same-more "$@"
+t-ref-same () {
+ local name="$1"
+ local val=`t-git-get-ref $name`
+ t-ref-same-val "$name" $val
+}
+
+t-ref-head () {
+ local val=`git rev-parse HEAD`
+ t-ref-same-val HEAD $val
+}
+
+t-ref-same-val () {
+ local name="$1"
+ local val=$2
+ case "$t_ref_val" in
+ '') ;;
+ "$val") ;;
+ *) fail "ref varies: $name: $val != $t_ref_val" ;;
+ esac
+ t_ref_val="$val"
+}
+
+t-refs-same-start () {
+ t_ref_val=''
}
t-refs-same-more () {
local g
for g in $*; do
- t-git-get-ref $g >$tmp/t.refn
- diff $tmp/t.ref1 $tmp/t.refn
+ t-ref-same $g
done
}
t-refs-notexist () {
+ local val
for g in $*; do
- t-git-get-ref $g >$tmp/t.refx
- diff /dev/null $tmp/t.refx
+ val=`t-git-get-ref $g >$tmp/t.refx`
+ if [ "x$val" != x ]; then
+ fail "ref $g unexpectedly exists ($val)"
+ fi
done
}
@@ -162,14 +189,16 @@ t-pushed-good () {
}
t-ref-dsc-dgit () {
- perl -e '
+ local dsc=${p}_${v}.dsc
+ local val=`perl -e '
use Dpkg::Control::Hash;
my $h = new Dpkg::Control::Hash allow_pgp=>1;
$h->parse(\*STDIN,"dsc");
my $ref = $h->{"Dgit"},"\n";
die unless $ref =~ m/^\w+\b/;
print $ref,"\n";
- ' <$tmp/incoming/${p}_${v}.dsc >$tmp/t.ref1
+ ' <$tmp/incoming/$dsc`
+ t-ref-same-val $dsc "$val"
}
t-apply-diff () {